Eclipse Remote Application Platform

## org.eclipse.swt.layout
Class RowLayout

    java.lang.Object
      org.eclipse.swt.widgets.Layout
          org.eclipse.swt.layout.RowLayout

    public final class RowLayout

extends Layout

Instances of this class determine the size and position of the children of a `Composite` by placing them either in horizontal rows or vertical columns within the parent `Composite`.

`RowLayout` aligns all controls in one row if the `type` is set to horizontal, and one column if it is set to vertical. It has the ability to wrap, and provides configurable margins and spacing. `RowLayout` has a number of configuration fields. In addition, the height and width of each control in a `RowLayout` can be specified by setting a `RowData` object into the control using `setLayoutData ()`.

The following example code creates a `RowLayout`, sets all of its fields to non-default values, and then sets it into a `Shell`.

        RowLayout rowLayout = new RowLayout();
        rowLayout.wrap = false;
        rowLayout.pack = false;
        rowLayout.justify = true;
        rowLayout.type = SWT.VERTICAL;
        rowLayout.marginLeft = 5;
        rowLayout.marginTop = 5;
        rowLayout.marginRight = 5;
        rowLayout.marginBottom = 5;
        rowLayout.spacing = 0;
        shell.setLayout(rowLayout);

If you are using the default field values, you only need one line of code:

        shell.setLayout(new RowLayout());

Since:
  1.0
See Also:
  `RowData`, RowLayout snippets, SWT Example: LayoutExample, Sample code and further information

Field Summary
`boolean` `center` center specifies whether the controls in a row should be centered vertically in each cell for horizontal layouts, or centered horizontally in each cell for vertical layouts.
`boolean` `fill` fill specifies whether the controls in a row should be all the same height for horizontal layouts, or the same width for vertical layouts.
`boolean` `justify` justify specifies whether the controls in a row should be fully justified, with any extra space placed between the controls.
`int` `marginBottom` marginBottom specifies the number of pixels of vertical margin that will be placed along the bottom edge of the layout.
`int` `marginHeight` marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout.
`int` `marginLeft` marginLeft specifies the number of pixels of horizontal margin that will be placed along the left edge of the layout.
`int` `marginRight` marginRight specifies the number of pixels of horizontal margin that will be placed along the right edge of the layout.
`int` `marginTop` marginTop specifies the number of pixels of vertical margin that will be placed along the top edge of the layout.
`int` `marginWidth` marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout.
`boolean` `pack` pack specifies whether all controls in the layout take their preferred size.
`int` `spacing` spacing specifies the number of pixels between the edge of one cell and the edge of its neighbouring cell.
`int` `type` type specifies whether the layout places controls in rows or columns.
`boolean` `wrap` wrap specifies whether a control will be wrapped to the next row if there is insufficient space on the current row.

Constructor Summary
`RowLayout()` Constructs a new instance of this class.
`RowLayout(int type)` Constructs a new instance of this class given the type.

Method Summary
`protected Point` `computeSize(Composite composite, int wHint, int hHint, boolean flushCache)` Computes and returns the size of the specified composite's client area according to this layout.
`protected boolean` `flushCache(Control control)` Instruct the layout to flush any cached values associated with the control specified in the argument `control`.
`protected void` `layout(Composite composite, boolean flushCache)` Lays out the children of the specified composite according to this layout.
`java.lang.String` `toString()` Returns a string containing a concise, human-readable description of the receiver.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### type

    public int type

  type specifies whether the layout places controls in rows or columns. The default value is HORIZONTAL. Possible values are:
  - HORIZONTAL: Position the controls horizontally from left to right
  - VERTICAL: Position the controls vertically from top to bottom

### marginWidth

    public int marginWidth

  marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout. The default value is 0.

### marginHeight

    public int marginHeight

  marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout. The default value is 0.

### spacing

    public int spacing

  spacing specifies the number of pixels between the edge of one cell and the edge of its neighbouring cell. The default value is 3.

### wrap

    public boolean wrap

  wrap specifies whether a control will be wrapped to the next row if there is insufficient space on the current row. The default value is true.

### pack

    public boolean pack

  pack specifies whether all controls in the layout take their preferred size. If pack is false, all controls will have the same size which is the size required to accommodate the largest preferred height and the largest preferred width of all the controls in the layout. The default value is true.

### fill

    public boolean fill

  fill specifies whether the controls in a row should be all the same height for horizontal layouts, or the same width for vertical layouts. The default value is false.

### center

    public boolean center

  center specifies whether the controls in a row should be centered vertically in each cell for horizontal layouts, or centered horizontally in each cell for vertical layouts. The default value is false.

  Since:
    1.2

### justify

    public boolean justify

  justify specifies whether the controls in a row should be fully justified, with any extra space placed between the controls. The default value is false.

### marginLeft

    public int marginLeft

  marginLeft specifies the number of pixels of horizontal margin that will be placed along the left edge of the layout. The default value is 3.

### marginTop

    public int marginTop

  marginTop specifies the number of pixels of vertical margin that will be placed along the top edge of the layout. The default value is 3.

### marginRight

    public int marginRight

  marginRight specifies the number of pixels of horizontal margin that will be placed along the right edge of the layout. The default value is 3.

### marginBottom

    public int marginBottom

  marginBottom specifies the number of pixels of vertical margin that will be placed along the bottom edge of the layout. The default value is 3.

Constructor Detail

### RowLayout

    public RowLayout()

  Constructs a new instance of this class.

### RowLayout

    public RowLayout(int type)

  Constructs a new instance of this class given the type.

  Parameters:
    `type` - the type of row layout

Method Detail

### computeSize

    protected Point computeSize(Composite composite,
                                int wHint,
                                int hHint,
                                boolean flushCache)

  Description copied from class: `Layout`
  Computes and returns the size of the specified composite's client area according to this layout.

  This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

  When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

  Specified by:
    `computeSize` in class `Layout`
  Parameters:
    `composite` - a composite widget using this layout
    `wHint` - width (`SWT.DEFAULT` for preferred size)
    `hHint` - height (`SWT.DEFAULT` for preferred size)
    `flushCache` - `true` means flush cached layout values
  Returns:
    a point containing the computed size (width, height)
  See Also:
    `Layout.layout(org.eclipse.swt.widgets.Composite, boolean)`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

### flushCache

    protected boolean flushCache(Control control)

  Description copied from class: `Layout`
  Instruct the layout to flush any cached values associated with the control specified in the argument `control`.

  Overrides:
    `flushCache` in class `Layout`
  Parameters:
    `control` - a control managed by this layout
  Returns:
    true if the Layout has flushed all cached information associated with control

### layout

    protected void layout(Composite composite,
                          boolean flushCache)

  Description copied from class: `Layout`
  Lays out the children of the specified composite according to this layout.

  This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

  When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

  When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

  Specified by:
    `layout` in class `Layout`
  Parameters:
    `composite` - a composite widget using this layout
    `flushCache` - `true` means flush cached layout values

### toString

    public java.lang.String toString()

  Returns a string containing a concise, human-readable description of the receiver.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a string representation of the layout

Eclipse Remote Application Platform

Copyright (c) EclipseSource and others 2002, 2013. All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0